package model

import "shylinux.com/x/mysql-story/src/db"

const (
	UID         = "uid"
	NAME        = "name"
	GRADE       = "grade"
	CREATED_AT  = "created_at"
	USER_UID    = "user_uid"
	CLASS_UID   = "class_uid"
	CLASS_NAME  = "class_name"
	SCHOOL_UID  = "school_uid"
	SCHOOL_NAME = "school_name"
)

type UserClass struct {
	db.Model
	UserUID  string `gorm:"type:char(32);index"`
	ClassUID string `gorm:"type:char(32)";index`
}
type Class struct {
	db.ModelWithUID
	SchoolUID string `gorm:"type:char(32)"`
	Grade     string `gorm:"type:char(32)"`
	Name      string `gorm:"type:varchar(256)"`
}
type School struct {
	db.ModelWithUID
	CityUID string `gorm:"type:char(32);index"`
	Name    string `gorm:"type:varchar(256)"`
	Info    string
}
type Homework struct {
	db.ModelWithUID
	ClassUID string `gorm:"type:char(32);index"`
	UserUID  string `gorm:"type:char(32)"`
	Content  string
}

func init() { db.CmdModels("", &UserClass{}, &Class{}, &School{}, &Homework{}) }
